package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;

import abc.impact.impact.ComputationImpact;
import abc.impact.impact.ComputationImpact.ComputationImpactType;

public final class ComputationImpactTreeNode extends AbstractTreeNode 
	implements IActCollapse {

	private final ComputationImpact computationImapct;
	
	public ComputationImpactTreeNode(ITreeNode parent, final ComputationImpact computationImapct) {
		super(parent);
		this.computationImapct = computationImapct;
		this.name = computationImapct.toString();
		if (computationImapct.getType() == ComputationImpactType.ADDITION) {
			this.image = ImageFactory.COMPUTATION_ADDITION.getImage();
		}
		if (computationImapct.getType() == ComputationImpactType.ELIMINATION) {
			this.image = ImageFactory.COMPUTATION_ELIMINATION.getImage();
		}
		if (computationImapct.getType() == ComputationImpactType.CONDITIONAL_SUBSTITUTION) {
			this.image = ImageFactory.COMPUTATION_CONDITIONAL_SUBSTITUTION.getImage();
		}
		if (computationImapct.getType() == ComputationImpactType.DEFINITE_SUBSTITUTION) {
			this.image = ImageFactory.COMPUTATION_DEFINITE_SUBSTITUTION.getImage();
		}
		if (computationImapct.getType() == ComputationImpactType.MIXED) {
			this.image = ImageFactory.COMPUTATION_MIXED.getImage();
		}
	}

	
	public ComputationImpact getComputationImapct() {
		return computationImapct;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}
}
