package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;

import polyglot.util.Position;
import abc.impact.impact.Mutation;
import ca.mcgill.sable.abc.impact.visualizer.actions.RunImpactAnalysisActionDelegate;
import ca.mcgill.sable.abc.impact.visualizer.util.ImpactPluginUtil;

public final class MutationMutateStmtTreeNode extends AbstractTreeNode 
	implements IActPosition {

	private final Mutation mutation;
	
	public MutationMutateStmtTreeNode(ITreeNode parent, final Mutation mutation) {
		super(parent);
		this.mutation = mutation;
		String pos = mutation.getPosition().toString();
		String projectOSPath = RunImpactAnalysisActionDelegate.getCurrentProject().getLocation().toOSString();
		if (pos.startsWith(projectOSPath)) {
			name = pos.substring(projectOSPath.length()+1);
		} else {
			name = pos;
		}
		this.image = ImageFactory.CODE.getImage();
	}

	public Mutation getMutation() {
		return mutation;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}

	public RevealData getRevealData() {
		Position pos = mutation.getPosition();
		return new RevealData(ImpactPluginUtil.getFileFromAbsolutePath(pos.file()), pos);
	}
}
