package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.ui.JavaUI;

import soot.SootClass;
import abc.impact.impact.Mutation;
import ca.mcgill.sable.abc.impact.visualizer.actions.RunImpactAnalysisActionDelegate;

public final class MutationMutatedTypeFieldDeclClassTreeNode extends
		AbstractTreeNode implements IActJavaElement, 
		IProvideJavaElementImage {
	
	private final Mutation mutation;
	private final IJavaElement jEle;
	
	public MutationMutatedTypeFieldDeclClassTreeNode(ITreeNode parent, final Mutation mutation) {
		super(parent);
		this.mutation = mutation;
		
		SootClass declClass = mutation.getMutatedFieldDeclClass();
		this.name = declClass.getShortName() + "." + mutation.getMutatedFieldName();
		this.image = JavaUI.getSharedImages().getImage(
				org.eclipse.jdt.ui.ISharedImages.IMG_FIELD_PUBLIC); //backup image
		
		IJavaElement ret = null;
		try {
			IJavaProject jProject = JavaCore.create(RunImpactAnalysisActionDelegate.getCurrentProject());
			IType jType = jProject.findType(declClass.getName());
			ret = jType;
			
			// try to find field further
			IField jField = jType.getField(mutation.getMutatedFieldName());
			if (jField != null && jField.exists()) {
				ret = jField;
			}
		} catch (JavaModelException e) {
			e.printStackTrace();
		} catch (Exception e) { //prevent exceptions ceasing the following code 
			e.printStackTrace();
		}
		this.jEle = ret;
	}

	public IJavaElement getJavaElement() {
		return jEle;
	}

	public Mutation getMutation() {
		return mutation;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}

}
