package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;

import polyglot.util.Position;
import abc.impact.impact.StateImpact;
import ca.mcgill.sable.abc.impact.visualizer.util.ImpactPluginUtil;

public final class StateImpactAdviceStmtTreeNode extends AbstractTreeNode 
	implements IActPosition {

	private final StateImpact stateImpact;
	
	public StateImpactAdviceStmtTreeNode(ITreeNode parent, final StateImpact stateImpact) {
		super(parent);
		this.stateImpact = stateImpact;
		String pos = stateImpact.getPosition().toString();
		this.name = stateImpact.getAdviceDecl().getAspect().getName() + pos.substring(pos.lastIndexOf(':'));
		this.image = ImageFactory.CODE_ASPECT.getImage();
	}
	
	public StateImpact getStateImpact() {
		return stateImpact;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}

	public RevealData getRevealData() {
		Position pos = stateImpact.getPosition();
		return new RevealData(ImpactPluginUtil.getFileFromAbsolutePath(pos.file()), pos);
	}
}
