/**
 * 
 */
package ca.mcgill.sable.abc.impact.visualizer.views;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import ca.mcgill.sable.abc.impact.visualizer.model.ITreeNode;

class ImpactViewContentProvider implements IStructuredContentProvider,
		ITreeContentProvider {
	
//	private TreeViewer viewer;

	public void inputChanged(Viewer v, Object oldInput, Object newInput) {
//		this.viewer = (TreeViewer)v;
	}

	public void dispose() {
	}

	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof ITreeNode) {
			return getChildren(inputElement);
		}
		return new Object[0];
	}

	public Object getParent(Object child) {
		if (child instanceof ITreeNode) {
			return ((ITreeNode) child).getParent();
		}
		return null;
	}

	public Object[] getChildren(Object parent) {
		if (parent instanceof ITreeNode) {
			return ((ITreeNode) parent).getChildren().toArray();
		}
		return new Object[0];
	}

	public boolean hasChildren(Object parent) {
		if (parent instanceof ITreeNode)
			return ((ITreeNode) parent).hasChildren();
		return false;
	}

//	/*
//	 * We will set up a dummy model to initialize tree heararchy.
//	 * In a real code, you will connect to a real model and
//	 * expose its hierarchy.
//	 */
//	private void initialize() {
//	}
}